//+------------------------------------------------------------------+
//|                                                 RSIFilter_v1.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window
#property indicator_minimum -2
#property indicator_maximum 2
#property indicator_buffers 2
#property indicator_color1 Orange
#property indicator_color2 SkyBlue
//---- input parameters
extern int PeriodRSI=14;
extern double UpperLevel1 = 70;
extern double LowerLevel1 = 30;
extern bool   InvertSignals = false;
//---- indicator buffers
double UpBuffer[];
double DnBuffer[];
double trend[];
double zone[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
   string short_name;
//---- indicator line
   IndicatorBuffers(4);
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,1);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,1);
   SetIndexBuffer(0,UpBuffer);
   SetIndexBuffer(1,DnBuffer);
   SetIndexBuffer(2,trend);
   SetIndexBuffer(3,zone);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- name for DataWindow and indicator subwindow label
   short_name="RSI Filter("+PeriodRSI+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"UpTrend");
   SetIndexLabel(1,"DownTrend");
//----
   SetIndexDrawBegin(0,PeriodRSI);
   SetIndexDrawBegin(1,PeriodRSI);
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| RSIFilter_v1                                                         |
//+------------------------------------------------------------------+
int start()
  {
   int shift;
   double RSI0;

   
   for(shift=Bars-PeriodRSI-1;shift>=0;shift--)
   {	
      RSI0=iRSI(NULL,0,PeriodRSI,PRICE_CLOSE,shift);
         UpBuffer[shift] = EMPTY_VALUE;
         DnBuffer[shift] = EMPTY_VALUE;
         trend[shift] = trend[shift+1];   	
         zone[shift]  = 0;
	      if (RSI0>UpperLevel1)  zone[shift]=  1; 
	      if (RSI0<LowerLevel1)  zone[shift]= -1; 
	      trend[shift] = trend[shift+1];
	        if (zone[shift]==0 && zone[shift+1]==-1) trend[shift] = 1;
	        if (zone[shift]==0 && zone[shift+1]== 1) trend[shift] =-1;
	        if (InvertSignals)
	        {
	           if (trend[shift]==-1) DnBuffer[shift] = -1;
	           if (trend[shift]== 1) UpBuffer[shift] =  1;
	        }
	        else
	        {
	           if (trend[shift]==-1) UpBuffer[shift] =  1;
	           if (trend[shift]== 1) DnBuffer[shift] = -1;
           }	           
	}
	return(0);	
 }

